# Braintree Flutter Drop-In 

A Flutter plugin that wraps the native
[Braintree Drop-In UI SDKs](https://www.braintreepayments.com/features/seamless-checkout/drop-in-ui).
Currently only supports Android.


## Installation

Add braintree to your `pubspec.yaml` file:
```yaml
dependencies:
  ...
  braintree_plugin: ^0.0.1
```


### Android

You must [migrate to AndroidX.](https://flutter.dev/docs/development/packages-and-plugins/androidx-compatibility)  
In `/app/build.gradle`, set your `minSdkVersion` to at least `21`.


## Usage

Import the plugin:
```dart
import 'package:braintree_plugin/braintree_plugin.dart';

```

Create a drop-in request object:
```dart
  Future<void> _pay(String token) async {
    String nonce;
    try {
      nonce = await BraintreePlugin.showDropIn(token);
    } catch (e) {
      nonce = e.message;
    }

    setState(() {
      _nonce = nonce;
    });
  }
```
