package max.xyz.braintree_plugin

import android.app.Activity
import android.content.Intent
import com.braintreepayments.api.dropin.DropInActivity
import com.braintreepayments.api.dropin.DropInRequest
import com.braintreepayments.api.dropin.DropInResult
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry
import io.flutter.plugin.common.PluginRegistry.Registrar

class BraintreePlugin : MethodCallHandler, PluginRegistry.ActivityResultListener {


    companion object {

        private const val DROP_IN_REQUEST = 0x01
        private var activity: Activity? = null
        private var mResult: Result? = null

        @JvmStatic
        fun registerWith(registrar: Registrar) {
            activity = registrar.activity()

            val channel = MethodChannel(registrar.messenger(), "xyz.max.braintreeplugin/showDropIn")
            channel.setMethodCallHandler(BraintreePlugin())
        }
    }

    override fun onMethodCall(call: MethodCall, result: Result) {
        if (call.method == "shoDropIn") {
            mResult = result
            val clientToken = call.argument<String>("clientToken")

            val dropInRequest = DropInRequest()
                    .clientToken(clientToken)
            activity?.startActivityForResult(dropInRequest.getIntent(activity), DROP_IN_REQUEST)

        } else {
            result.notImplemented()
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent): Boolean {
        if (requestCode == DROP_IN_REQUEST) {
            if (resultCode == Activity.RESULT_OK) {
                val result = data.getParcelableExtra<DropInResult>(DropInResult.EXTRA_DROP_IN_RESULT)
                mResult?.success(result.paymentMethodNonce!!.nonce)
            } else if (resultCode == Activity.RESULT_CANCELED) {
                mResult?.error("CANCELLED", "Purchase process was cancelled.", null)
            } else {
                val error = data.getSerializableExtra(DropInActivity.EXTRA_ERROR) as Exception
                mResult?.error("ERROR", error.message, null)
            }
            mResult = null
            return true
        }
        mResult = null
        return false
    }
}