import 'dart:async';

import 'package:braintree_plugin/braintree_plugin.dart';
import 'package:flutter/material.dart';

void main() => runApp(MyApp());

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _nonce = 'Unknown';
  final _controller = TextEditingController();

  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Center(
          child: Column(
            mainAxisSize: MainAxisSize.min,
            children: <Widget>[
              TextField(
                controller: _controller,
                decoration: InputDecoration(hintText: 'Your client token'),
              ),
              RaisedButton(
                child: Text('Pay'),
                onPressed: () => _pay(_controller.text),
              ),
              Text(_nonce),
            ],
          ),
        ),
      ),
    );
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> _pay(String token) async {
    String nonce;
//    "production_6n9xvtzk_fz6t5p5mw95f5jrm"
    try {
      nonce = await BraintreePlugin.showDropIn(token);
    } catch (e) {
      nonce = e.message;
    }

    // If the widget was removed from the tree while the asynchronous platform
    // message was in flight, we want to discard the reply rather than calling
    // setState to update our non-existent appearance.
    if (!mounted) return;

    setState(() {
      _nonce = nonce;
    });
  }
}
